## aubio 0.4.9

=== Makefile ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# This makefile contains simple rules to prepare, compile, test, and install
# aubio. Try one of the following rules:
#
# $ make configure
# $ make build
# $ make install
# $ make test_python

WAFCMD=python waf

#WAFOPTS:=
# turn on verbose mode
WAFOPTS += --verbose
# build wafopts
WAFOPTS += --destdir $(DESTDIR)
# multiple jobs
WAFOPTS += --jobs 4
# if HAVE_AUBIO_DOUBLE is defined, pass --enable-double to waf
# python/lib/moresetuptools.py also checks for HAVE_AUBIO_DOUBLE
WAFOPTS += $(shell [ -z $(HAVE_AUBIO_DOUBLE) ] || echo --enable-double )

PIPOPTS += --verbose

DESTDIR:=$(PWD)/build/dist
PYDESTDIR:=$(PWD)/build/pydist

# default install locations
PREFIX?=/usr/local
EXEC_PREFIX?=$(PREFIX)
LIBDIR?=$(PREFIX)/lib
INCLUDEDIR?=$(PREFIX)/include
DATAROOTDIR?=$(PREFIX)/share
MANDIR?=$(DATAROOTDIR)/man

# default python test command
PYTEST?=pytest --verbose

SOX=sox

TESTSOUNDS := python/tests/sounds

LCOVOPTS += --rc lcov_branch_coverage=1

all: build

checkwaf:
	@[ -f waf ] || make getwaf

getwaf:
	./scripts/get_waf.sh

expandwaf: getwaf
	[ -d wafilb ] || rm -fr waflib
	$(WAFCMD) --help > /dev/null
	mv .waf*/waflib . && rm -fr .waf*
	sed '/^#==>$$/,$$d' waf > waf2 && mv waf2 waf
	chmod +x waf && chmod -R go-w waflib

cleanwaf:
	rm -rf waf waflib .waf*

configure: checkwaf
	$(WAFCMD) configure $(WAFOPTS)

build: configure
	$(WAFCMD) build $(WAFOPTS)

install:
	# install
	$(WAFCMD) install $(WAFOPTS)

list_installed:
	find $(DESTDIR) -ls | sed 's|$(DESTDIR)|/«destdir»|'

list_installed_python:
	pip show -f aubio

list_all_installed: list_installed list_installed_python

uninstall:
	# uninstall
	$(WAFCMD) uninstall $(WAFOPTS)

delete_install:
	rm -rf $(PWD)/dist/test

build_python:
	# build python-aubio, using locally built libaubio if found
	python ./setup.py build

build_python_extlib:
	# build python-aubio using (locally) installed libaubio
	[ -f $(DESTDIR)/$(INCLUDEDIR)/aubio/aubio.h ]
	[ -d $(DESTDIR)/$(LIBDIR) ]
	[ -f $(DESTDIR)/$(LIBDIR)/pkgconfig/aubio.pc ]
	PKG_CONFIG_PATH=$(DESTDIR)/$(LIBDIR)/pkgconfig \
	CFLAGS="-I$(DESTDIR)/$(INCLUDEDIR)" \
	LDFLAGS="-L$(DESTDIR)/$(LIBDIR)" \
		make build_python

deps_python:
	# install or upgrade python requirements
	pip install $(PIPOPTS) --requirement requirements.txt

# use pip or distutils?
install_python: install_python_with_pip
uninstall_python: uninstall_python_with_pip
#install_python: install_python_with_distutils
#uninstall_python: uninstall_python_with_distutils

install_python_with_pip:
	# install package
	pip install $(PIPOPTS) .

uninstall_python_with_pip:
	# uninstall package
	( pip show aubio | grep -l aubio > /dev/null ) && \
	pip uninstall -y -v aubio || echo "info: aubio package is not installed"

install_python_with_distutils:
	./setup.py install $(PIPOPTS) $(DISTUTILSOPTS)

uninstall_python_with_distutils:
	#./setup.py uninstall
	[ -d $(PYDESTDIR)/$(LIBDIR) ] && echo Warning: did not clean $(PYDESTDIR)/$(LIBDIR) || true

force_uninstall_python:
	# ignore failure if not installed
	-make uninstall_python

local_dylib:
	# DYLD_LIBRARY_PATH is no more on mac os
	# create links from ~/lib/lib* to build/src/lib*
	[ -f $(PWD)/build/src/libaubio.[0-9].dylib ] && ( mkdir -p ~/lib && cp -prv build/src/libaubio.[0-9].dylib ~/lib ) || true

test_python: export LD_LIBRARY_PATH=$(DESTDIR)/$(LIBDIR)
test_python: export PYTHONPATH=$(PYDESTDIR)/$(LIBDIR)
test_python: local_dylib
	# run test with installed package
	$(PYTEST)

clean_python:
	./setup.py clean

check_clean_python:
	# check cleaning a second time works
	make clean_python
	make clean_python

clean: checkwaf
	# optionnaly clean before build
	-$(WAFCMD) clean
	# remove possible left overs
	-rm -rf doc/_build

check_clean:
	# check cleaning after build works
	$(WAFCMD) clean
	# check cleaning a second time works
	$(WAFCMD) clean

distclean:
	$(WAFCMD) distclean
	-rm -rf doc/_build/
	-rm -rf doc/web/

check_distclean:
	make distclean

distcheck: checkwaf
	$(WAFCMD) distcheck $(WAFOPTS)

help:
	$(WAFCMD) --help

create_test_sounds:
	-[ -z `which $(SOX)` ] && ( echo $(SOX) could not be found) || true
	-mkdir -p $(TESTSOUNDS)
	-$(SOX) -r 44100 -b 16 -n "$(TESTSOUNDS)/44100Hz_1f_silence.wav"      trim 0 1s
	-$(SOX) -r 22050 -b 16 -n "$(TESTSOUNDS)/22050Hz_5s_brownnoise.wav"   synth 5    brownnoise      vol 0.9
	-$(SOX) -r 32000 -b 16 -n "$(TESTSOUNDS)/32000Hz_127f_sine440.wav"    synth 127s sine 440        vol 0.9
	-$(SOX) -r  8000 -b 16 -n "$(TESTSOUNDS)/8000Hz_30s_silence.wav"      trim 0 30
	-$(SOX) -r 48000 -b 32 -n "$(TESTSOUNDS)/48000Hz_60s_sweep.wav"       synth 60   sine 100-20000  vol 0.9
	-$(SOX) -r 44100 -b 16 -n "$(TESTSOUNDS)/44100Hz_44100f_sine441.wav"  synth 44100s   sine 441 	vol 0.9
	-$(SOX) -r 44100 -b 16 -n "$(TESTSOUNDS)/44100Hz_100f_sine441.wav"    synth 100s sine 441 	vol 0.9

# build only libaubio, no python-aubio
test_lib_only: clean distclean configure build install list_installed
# additionally, clean after a fresh build
test_lib_only_clean: test_lib_only uninstall check_clean check_distclean

# build libaubio, build and test python-aubio against it
test_lib_python: force_uninstall_python deps_python \
	clean_python clean distclean \
	configure build build_python \
	install install_python \
	test_python \
	list_all_installed

test_lib_python_clean: test_lib_python \
	uninstall_python uninstall \
	check_clean_python \
	check_clean \
	check_distclean

# build libaubio, install it, build python-aubio against it
test_lib_install_python: force_uninstall_python deps_python \
	clean_python distclean \
	configure build \
	install \
	build_python_extlib \
	install_python \
	test_python \
	list_all_installed

test_lib_install_python_clean: test_lib_install_python \
	uninstall_python \
	delete_install \
	check_clean_python \
	check_distclean

# build a python-aubio that includes libaubio
test_python_only: force_uninstall_python deps_python \
	clean_python clean distclean \
	build_python \
	install_python \
	test_python \
	list_installed_python

test_python_only_clean: test_python_only \
	uninstall_python \
	check_clean_python

coverage_cycle: coverage_zero_counters coverage_report

coverage_zero_counters:
	lcov --zerocounters --directory .

coverage: export CFLAGS=--coverage
coverage: export LDFLAGS=--coverage
coverage: export PYTHONPATH=$(PWD)/python/lib
coverage: export LD_LIBRARY_PATH=$(PWD)/build/src
coverage: force_uninstall_python deps_python \
	clean_python clean distclean build local_dylib
	# capture coverage after running c tests
	lcov $(LCOVOPTS) --capture --no-external --directory . \
		--output-file build/coverage_lib.info
	# build and test python
	pip install -v -e .
	# run tests, with python coverage
	coverage run `which pytest`
	# capture coverage again
	lcov $(LCOVOPTS) --capture --no-external --directory . \
		--output-file build/coverage_python.info
	# merge both coverage info files
	lcov $(LCOVOPTS) -a build/coverage_python.info -a build/coverage_lib.info \
		--output-file build/coverage.info
	# remove tests
	lcov $(LCOVOPTS) --remove build/coverage.info '*/ooura_fft8g*' \
		--output-file build/coverage_lib.info

# make sure we don't build the doc, which builds a temporary python module
coverage_report: export WAFOPTS += --disable-docs
coverage_report: coverage
	# generate report with lcov's genhtml
	genhtml build/coverage_lib.info --output-directory build/coverage_c \
		--branch-coverage --highlight --legend
	# generate python report with coverage python package
	coverage report
	coverage html -d build/coverage_python
	# show links to generated reports
	for i in $$(ls build/coverage_*/index.html); do echo file://$(PWD)/$$i; done

sphinx: configure
	$(WAFCMD) sphinx $(WAFOPTS)

doxygen: configure
	$(WAFCMD) doxygen $(WAFOPTS)

manpages: configure
	$(WAFCMD) manpages $(WAFOPTS)

html: doxygen sphinx

docs: html manpages

dist: distclean expandwaf
	$(WAFCMD) dist

=== requirements.txt ===
numpy
pytest

=== wscript ===
#! /usr/bin/python
#
# usage:
#   $ python waf --help
#
# example:
#   $ ./waf distclean configure build
#
# Note: aubio uses the waf build system, which relies on Python. Provided you
# have Python installed, you do *not* need to install anything to build aubio.
# For more info about waf, see http://code.google.com/p/waf/ .

import sys

APPNAME = 'aubio'

from this_version import *

VERSION = get_aubio_version()
LIB_VERSION = get_libaubio_version()

top = '.'
out = 'build'

def add_option_enable_disable(ctx, name, default = None,
        help_str = None, help_disable_str = None):
    if help_str == None:
        help_str = 'enable ' + name + ' support'
    if help_disable_str == None:
        help_disable_str = 'do not ' + help_str
    ctx.add_option('--enable-' + name, action = 'store_true',
            default = default,
            dest = 'enable_' + name.replace('-','_'),
            help = help_str)
    ctx.add_option('--disable-' + name, action = 'store_false',
            #default = default,
            dest = 'enable_' + name.replace('-','_'),
            help = help_disable_str )

def options(ctx):
    ctx.add_option('--build-type', action = 'store',
            default = "release",
            choices = ('debug', 'release'),
            dest = 'build_type',
            help = 'whether to compile with (--build-type=release)' \
                    ' or without (--build-type=debug)' \
                    ' compiler opimizations [default: release]')
    add_option_enable_disable(ctx, 'fftw3f', default = False,
            help_str = 'compile with fftw3f instead of ooura (recommended)',
            help_disable_str = 'do not compile with fftw3f')
    add_option_enable_disable(ctx, 'fftw3', default = False,
            help_str = 'compile with fftw3 instead of ooura',
            help_disable_str = 'do not compile with fftw3')
    add_option_enable_disable(ctx, 'intelipp', default = False,
            help_str = 'use Intel IPP libraries (auto)',
            help_disable_str = 'do not use Intel IPP libraries')
    add_option_enable_disable(ctx, 'complex', default = False,
            help_str ='compile with C99 complex',
            help_disable_str = 'do not use C99 complex (default)' )
    add_option_enable_disable(ctx, 'jack', default = None,
            help_str = 'compile with jack (auto)',
            help_disable_str = 'disable jack support')
    add_option_enable_disable(ctx, 'sndfile', default = None,
            help_str = 'compile with sndfile (auto)',
            help_disable_str = 'disable sndfile')
    add_option_enable_disable(ctx, 'avcodec', default = None,
            help_str = 'compile with libavcodec (auto)',
            help_disable_str = 'disable libavcodec')
    add_option_enable_disable(ctx, 'samplerate', default = None,
            help_str = 'compile with samplerate (auto)',
            help_disable_str = 'disable samplerate')
    add_option_enable_disable(ctx, 'memcpy', default = True,
            help_str = 'use memcpy hacks (default)',
            help_disable_str = 'do not use memcpy hacks')
    add_option_enable_disable(ctx, 'double', default = False,
            help_str = 'compile in double precision mode',
            help_disable_str = 'compile in single precision mode (default)')
    add_option_enable_disable(ctx, 'fat', default = False,
            help_str = 'build fat binaries (darwin only)',
            help_disable_str = 'do not build fat binaries (default)')
    add_option_enable_disable(ctx, 'accelerate', default = None,
            help_str = 'use Accelerate framework (darwin only) (auto)',
            help_disable_str = 'do not use Accelerate framework')
    add_option_enable_disable(ctx, 'apple-audio', default = None,
            help_str = 'use CoreFoundation (darwin only) (auto)',
            help_disable_str = 'do not use CoreFoundation framework')
    add_option_enable_disable(ctx, 'blas', default = False,
            help_str = 'use BLAS acceleration library (no)',
            help_disable_str = 'do not use BLAS library')
    add_option_enable_disable(ctx, 'atlas', default = False,
            help_str = 'use ATLAS acceleration library (no)',
            help_disable_str = 'do not use ATLAS library')
    add_option_enable_disable(ctx, 'wavread', default = True,
            help_str = 'compile with source_wavread (default)',
            help_disable_str = 'do not compile source_wavread')
    add_option_enable_disable(ctx, 'wavwrite', default = True,
            help_str = 'compile with source_wavwrite (default)',
            help_disable_str = 'do not compile source_wavwrite')

    add_option_enable_disable(ctx, 'docs', default = None,
            help_str = 'build documentation (auto)',
            help_disable_str = 'do not build documentation')

    add_option_enable_disable(ctx, 'tests', default = True,
            help_str = 'build tests (true)',
            help_disable_str = 'do not build or run tests')

    add_option_enable_disable(ctx, 'examples', default = True,
            help_str = 'build examples (true)',
            help_disable_str = 'do not build examples')

    ctx.add_option('--with-target-platform', type='string',
            help='set target platform for cross-compilation',
            dest='target_platform')

    ctx.load('compiler_c')
    ctx.load('waf_unit_test')
    ctx.load('gnu_dirs')
    ctx.load('waf_gensyms', tooldir='.')

def configure(ctx):
    target_platform = sys.platform
    if ctx.options.target_platform:
        target_platform = ctx.options.target_platform

    from waflib import Options

    if target_platform=='emscripten':
        ctx.load('c_emscripten')
    else:
        ctx.load('compiler_c')

    ctx.load('waf_unit_test')
    ctx.load('gnu_dirs')
    ctx.load('waf_gensyms', tooldir='.')

    # check for common headers
    ctx.check(header_name='stdlib.h')
    ctx.check(header_name='stdio.h')
    ctx.check(header_name='math.h')
    ctx.check(header_name='string.h')
    ctx.check(header_name='errno.h')
    ctx.check(header_name='limits.h')
    ctx.check(header_name='stdarg.h')
    ctx.check(header_name='getopt.h', mandatory = False)
    ctx.check(header_name='unistd.h', mandatory = False)

    ctx.env['DEST_OS'] = target_platform

    if ctx.options.build_type == "debug":
        ctx.define('DEBUG', 1)
    else:
        ctx.define('NDEBUG', 1)

    if ctx.env.CC_NAME != 'msvc':
        if ctx.options.build_type == "debug":
            # no optimization in debug mode
            ctx.env.prepend_value('CFLAGS', ['-O0'])
        else:
            if target_platform == 'emscripten':
                # -Oz for small js file generation
                ctx.env.prepend_value('CFLAGS', ['-Oz'])
            else:
                # default to -O2 in release mode
                ctx.env.prepend_value('CFLAGS', ['-O2'])
        # enable debug symbols and configure warnings
        ctx.env.prepend_value('CFLAGS', ['-g', '-Wall', '-Wextra'])
    else:
        # enable debug symbols
        ctx.env.CFLAGS += ['/Z7']
        # /FS flag available in msvc >= 12 (2013)
        if 'MSVC_VERSION' in ctx.env and ctx.env.MSVC_VERSION >= 12:
            ctx.env.CFLAGS += ['/FS']
        ctx.env.LINKFLAGS += ['/DEBUG', '/INCREMENTAL:NO']
        # configure warnings
        ctx.env.CFLAGS += ['/W4', '/D_CRT_SECURE_NO_WARNINGS']
        # ignore "possible loss of data" warnings
        ctx.env.CFLAGS += ['/wd4305', '/wd4244', '/wd4245', '/wd4267']
        # ignore "unreferenced formal parameter" warnings
        ctx.env.CFLAGS += ['/wd4100']
        # set optimization level and runtime libs
        if (ctx.options.build_type == "release"):
            ctx.env.CFLAGS += ['/Ox']
            ctx.env.CFLAGS += ['/MD']
        else:
            assert(ctx.options.build_type == "debug")
            ctx.env.CFLAGS += ['/MDd']

    ctx.check_cc(lib='m', uselib_store='M', mandatory=False)

    if target_platform not in ['win32', 'win64']:
        ctx.env.CFLAGS += ['-fPIC']
    else:
        ctx.define('HAVE_WIN_HACKS', 1)
        ctx.env['cshlib_PATTERN'] = 'lib%s.dll'

    if target_platform == 'darwin' and ctx.options.enable_fat:
        ctx.env.CFLAGS += ['-arch', 'i386', '-arch', 'x86_64']
        ctx.env.LINKFLAGS += ['-arch', 'i386', '-arch', 'x86_64']
        MINSDKVER="10.4"
        ctx.env.CFLAGS += [ '-mmacosx-version-min=' + MINSDKVER ]
        ctx.env.LINKFLAGS += [ '-mmacosx-version-min=' + MINSDKVER ]

    if target_platform in [ 'darwin', 'ios', 'iosimulator']:
        if (ctx.options.enable_apple_audio != False):
            ctx.env.FRAMEWORK += ['CoreFoundation', 'AudioToolbox']
            ctx.define('HAVE_SOURCE_APPLE_AUDIO', 1)
            ctx.define('HAVE_SINK_APPLE_AUDIO', 1)
            ctx.msg('Checking for AudioToolbox.framework', 'yes')
        else:
            ctx.msg('Checking for AudioToolbox.framework', 'no (disabled)',
                    color = 'YELLOW')
        if (ctx.options.enable_accelerate != False):
            ctx.define('HAVE_ACCELERATE', 1)
            ctx.env.FRAMEWORK += ['Accelerate']
            ctx.msg('Checking for Accelerate framework', 'yes')
        else:
            ctx.msg('Checking for Accelerate framework', 'no (disabled)',
                    color = 'YELLOW')

    if target_platform in [ 'ios', 'iosimulator' ]:
        MINSDKVER="6.1"
        ctx.env.CFLAGS += ['-std=c99']
        if (ctx.options.enable_apple_audio != False):
            ctx.define('HAVE_AUDIO_UNIT', 1)
            #ctx.env.FRAMEWORK += ['CoreFoundation', 'AudioToolbox']
        if target_platform == 'ios':
            DEVROOT = "/Applications/Xcode.app/Contents"
            DEVROOT += "/Developer/Platforms/iPhoneOS.platform/Developer"
            SDKROOT = "%(DEVROOT)s/SDKs/iPhoneOS.sdk" % locals()
            ctx.env.CFLAGS += [ '-fembed-bitcode' ]
            ctx.env.CFLAGS += [ '-arch', 'arm64' ]
            ctx.env.CFLAGS += [ '-arch', 'armv7' ]
            ctx.env.CFLAGS += [ '-arch', 'armv7s' ]
            ctx.env.LINKFLAGS += [ '-arch', 'arm64' ]
            ctx.env.LINKFLAGS += ['-arch', 'armv7']
            ctx.env.LINKFLAGS += ['-arch', 'armv7s']
            ctx.env.CFLAGS += [ '-miphoneos-version-min=' + MINSDKVER ]
            ctx.env.LINKFLAGS += [ '-miphoneos-version-min=' + MINSDKVER ]
        else:
            DEVROOT = "/Applications/Xcode.app/Contents"
            DEVROOT += "/Developer/Platforms/iPhoneSimulator.platform/Developer"
            SDKROOT = "%(DEVROOT)s/SDKs/iPhoneSimulator.sdk" % locals()
            ctx.env.CFLAGS += [ '-arch', 'i386' ]
            ctx.env.CFLAGS += [ '-arch', 'x86_64' ]
            ctx.env.LINKFLAGS += ['-arch', 'i386']
            ctx.env.LINKFLAGS += ['-arch', 'x86_64']
            ctx.env.CFLAGS += [ '-mios-simulator-version-min=' + MINSDKVER ]
            ctx.env.LINKFLAGS += [ '-mios-simulator-version-min=' + MINSDKVER ]
        ctx.env.CFLAGS += [ '-isysroot' , SDKROOT]
        ctx.env.LINKFLAGS += [ '-isysroot' , SDKROOT]

    if target_platform == 'emscripten':
        if ctx.options.build_type == "debug":
            ctx.env.cshlib_PATTERN = '%s.js'
            ctx.env.LINKFLAGS += ['-s','ASSERTIONS=2']
            ctx.env.LINKFLAGS += ['-s','SAFE_HEAP=1']
            ctx.env.LINKFLAGS += ['-s','ALIASING_FUNCTION_POINTERS=0']
            ctx.env.LINKFLAGS += ['-O0']
        else:
            ctx.env.LINKFLAGS += ['-Oz']
            ctx.env.cshlib_PATTERN = '%s.min.js'

        # doesnt ship file system support in lib
        ctx.env.LINKFLAGS_cshlib += ['-s', 'NO_FILESYSTEM=1']
        # put memory file inside generated js files for easier portability
        ctx.env.LINKFLAGS += ['--memory-init-file', '0']
        ctx.env.cprogram_PATTERN = "%s.js"
        ctx.env.cstlib_PATTERN = '%s.a'

        # tell emscripten functions we want to expose
        from python.lib.gen_external import get_c_declarations, \
                get_cpp_objects_from_c_declarations, \
                get_all_func_names_from_lib, \

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf _static
	-rm -rf $(BUILDDIR)/*

html:
	mkdir -p _static
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/aubio.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/aubio.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/aubio"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/aubio"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
aubio (0.4.9-5) unstable; urgency=medium

  * Salvage package on behalf of the debian-multimedia team (Closes: #1114989)
    + Fix Vcs-* stanzas to point to the multimedia-team repository

  * Add patch to fix FTBFS with ffmpeg-8.
    Thanks to Bernd Kuhls (Closes: #1115008)
  * Update Py3.12 patch to use raw-strings in regular expressions
  * Refresh patches with 'gbp pq' and group them by topic
  * Drop obsolete Rules-Requires-Root stanza.
  * Apply 'wrap-and-sort -ast'
  * Bump dh-compat to 13
  * Suppress false-positives in blhc check
  * Update copyright information
    + Add myself to copyright holders
    + Add 'licensecheck' target
    + Generate d/copyright_hints
  * Update d/watch to version 5
  * Update git repository layout to follow DEP-14
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 07 Oct 2025 10:08:21 +0200

aubio (0.4.9-4.7) unstable; urgency=medium

  * Non-maintainer upload.
  * Relax assert_equal to assert_almost_equal in unittests (Closes: #1095283)
  * Refresh patches
  * B-D on dh-sequence-numpy3
  * Use execute_after_dh_... rather than override_dh_... where appropriate

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 09 Feb 2025 23:11:11 +0100

aubio (0.4.9-4.6) unstable; urgency=medium

  * Non-maintainer upload.
  * Add Numpy 2.x patch (Closes: #1094369)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 05 Feb 2025 20:17:52 +0100

aubio (0.4.9-4.5) unstable; urgency=medium

  * Non-maintainer upload.

  * Backport fix for FTBFS with FFMpeg-7 from upstream via Ubuntu
    (Closes: #1072399)
  * Backport fix for FTBFS with Python3.12 from Ubuntu.
    Thanks to Zixing Liu <zixing.liu@canonical.com> (Closes: #1074827)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 05 Oct 2024 01:40:39 +0200

aubio (0.4.9-4.4) unstable; urgency=medium

  * Non-maintainer upload.

  [ Vladimir Petko ]
  * d/p/waflib-py312.patch: cherry-pick waf patch to resolve python 3.12
    build failure due to imp module removal. Closes: #1061736.

 -- Matthias Klose <doko@debian.org>  Wed, 07 Feb 2024 00:46:01 +0100

aubio (0.4.9-4.3) unstable; urgency=medium

  * Non-maintainer upload.
  * waf compatibility with Python3.11 (Closes: #1028178)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 15 Jan 2023 21:40:50 +0100

aubio (0.4.9-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch to build against ffmpeg-5.0 (Closes: #1004787)
  * Add salsa-ci configuration
  * Call dh_numpy3 to add dependency on numpy abi

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 30 Jun 2022 22:35:01 +0200

aubio (0.4.9-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Change build-depends from libavresample-dev to libswresample-dev
    the build logs and binary dependencies indicate the package was
    already using libswresample ( Closes: 971319 ).

 -- Peter Michael Green <plugwash@debian.org>  Thu, 09 Sep 2021 18:11:53 +0000

aubio (0.4.9-4) unstable; urgency=medium

  * debian/tests/control: remove py2 tests

 -- Paul Brossier <piem@debian.org>  Wed, 08 Jan 2020 13:39:53 +0100

aubio (0.4.9-3) unstable; urgency=medium

  * debian/control: remove python-aubio package (closes: #936161)
  * debian/rules: use only python3, cleaner py3 clean
  * debian/patches/wscript_py3.patch: add patch to build with current python
  * debian/upstream/metadata: add basic upstream description and reference
  * debian/control: bump to debhelper-compat 12, remove debian/compat,
    bump S-V to 4.4.1, add Rules-Requires-Root: no
  * debian/aubio-tools.manpages: install from debian/tmp
  * debian/libaubio-doc.*: move html doc to /u/s/d/libaubio-dev/api
  * debian/libaubio-doc.doc-base: update author email
  * debian/libaubio-doc.links: fix jquery link

 -- Paul Brossier <piem@debian.org>  Sat, 04 Jan 2020 18:34:15 +0100

aubio (0.4.9-2) unstable; urgency=medium

  * Add upstream patches to fix FTBFS on powerpc and i386

 -- Paul Brossier <piem@debian.org>  Fri, 21 Jun 2019 14:46:30 +0200

aubio (0.4.9-1) unstable; urgency=medium

  * New upstream version 0.4.9 (closes: #480018, #930186)
  * Fixes security issues (CVE-2018-19800, CVE-2018-19801, CVE-2018-19802)
  * debian/tests/control: also install built binaries
  * debian/patches: remove patches integrated upstream
  * debian/control: bump to S-V 4.3.0
  * debian/control, debian/tests: switch b-d from nose2 to pytest
  * debian/rules: switch to pytest, update clean target
  * debian/patches/fixtypos.patch: fix typos
  * debian/patches/series: remove patches integrated upstream
  * debian/libaubio-doc.dob-base: move documentation to api folder
  * debian/libaubio5.symbols: add new symbols since 0.4.8, remove unused
    symbols previously exported, add Build-Depends-Package field
  * debian/upstream/signing-key.asc: minimize key export

 -- Paul Brossier <piem@debian.org>  Thu, 20 Jun 2019 12:01:41 +0200

=== debian/control ===
Source: aubio
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Paul Brossier <piem@debian.org>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-numpy3,
 libasound2-dev,
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libfftw3-dev,
 libjack-dev | libjack-jackd2-dev,
 libpython3-dev,
 libsamplerate-dev,
 libsndfile1-dev,
 libswresample-dev,
 libtool,
 python3-all-dev,
 python3-numpy,
 python3-pytest,
 python3-setuptools,
 sox,
 txt2man,
Build-Depends-Indep:
 doxygen,
 libjs-jquery,
 libjs-mathjax,
Standards-Version: 4.7.2
Homepage: https://aubio.org
Vcs-Git: https://salsa.debian.org/multimedia-team/aubio.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/aubio

Package: libaubio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libaubio5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for audio and music analysis, synthesis, and effects
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package contains the development files for libaubio.

Package: libaubio5
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libaubio4,
Description: library for audio segmentation
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package provides the shared library libaubio.

Package: aubio-tools
Architecture: any
Depends:
 python3-aubio (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: library for audio segmentation -- utilities
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package provides command line tools to run the different algorithms.

Package: libaubio-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 libjs-mathjax,
 ${misc:Depends},
Description: library for audio segmentation -- documentation
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package provides the documentation for the C interface.

Package: python3-aubio
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 python3-matplotlib,
Description: Python 3 interface for aubio, a library for audio segmentation
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package provides the aubio module for Python 3.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

LDFLAGS += -Wl,--as-needed

WAF_OPTIONS = --verbose --destdir=debian/tmp --prefix=/usr --enable-fftw3f
WAF_OPTIONS += --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
WAF_CMD = python3 ./waf

export PYBUILD_NAME=aubio
export PYBUILD_AFTER_INSTALL_python2=rm -vrf '{destdir}/usr/bin'
export PYBUILD_AFTER_INSTALL_python3=mv '{destdir}/usr/bin/aubio' '{destdir}/usr/bin/aubiocut' '{dir}/debian/tmp/usr/bin'

export PYBUILD_BEFORE_TEST=make create_test_sounds
export PYBUILD_AFTER_TEST=rm -rf '{dir}/python/tests/sounds'
%:
	dh $@ --with python3 --buildsystem=pybuild

execute_after_dh_auto_clean:
	-$(WAF_CMD) distclean
	rm -rf python/ext/config.h
	rm -rf aubio.egg-info/
	rm -f this_version.pyc
	rm -f waf_gensyms.pyc
	rm -rf python/tests/sounds
	rm -rf .cache/ .pytest_cache/
	rm -rf waflib/*/__pycache__/
	rm -rf ./__pycache__/
	# extra rules to remove files manually
	#-find waf -name '*.pyc' -delete
	#rm -rf .waf* .lock-waf*
	#rm -rf build/ dist/ .waf* .lock-waf*
	#rm -rf python/gen/ aubio.egg-info
	#rm -rf python/lib/*.pyc python/lib/aubio/*.so
	#rm -rf debian/tmp
	#rm -rf manpages.refs manpages.links

override_dh_auto_configure:
	$(WAF_CMD) configure $(WAF_OPTIONS)

execute_before_dh_auto_build:
	@echo "blhc: ignore-line-regexp: ^\[[ 0-9]+/[ 0-9]+\] Compiling .*"
	$(WAF_CMD) build $(WAF_OPTIONS)

override_dh_auto_test:
	# run tests
	LD_LIBRARY_PATH=$(CURDIR)/build/src:$(LD_LIBRARY_PATH) \
		dh_auto_test -- --test-pytest --test-args $(CURDIR)/python/tests/

execute_before_dh_auto_install:
	# library
	$(WAF_CMD) install $(WAF_OPTIONS)


################ d/copyright helper ##############
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/tests/control ===
Tests:
 py3xtests,
Depends:
 python3-pytest,
 sox,
 @,
Restrictions:
 allow-stderr,

=== debian/watch ===
Version: 5

Source: https://aubio.org/pub/
Matching-Pattern: aubio-([0-9.]*)\.tar\.bz2
Pgpsigurlmangle: s/$/.asc/
